package clustering;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.List;

import clustering.node.Folder;
import clustering.node.Leaf;

import com.giantleap.common.nodebean.node.base.filter.AndFilter;
import com.giantleap.common.nodebean.node.base.filter.DoubleAttributeFilter;
import com.giantleap.common.nodebean.node.base.filter.HasAttributeFilter;
import com.giantleap.common.nodebean.node.base.filter.HasParentFilter;
import com.giantleap.common.nodebean.node.base.filter.NodeBeanFilter;
import com.giantleap.common.nodebean.node.base.filter.NodeClassFilter;
import com.giantleap.common.nodebean.node.base.filter.OrFilter;
import com.giantleap.common.nodebean.node.base.storage.id.NodeId;
import com.giantleap.common.nodebean.node.base.storage.node.Node;
import com.giantleap.common.nodebean.node.root.file.FileRootNode;
import com.giantleap.common.nodebean.persistence.JDOM.JDOMPersistenceMgr;

public class ClonalRelateClustering {

	/**
	 * @param args
	 */

	private List<String> jgenes;

	private List<String> names;

	private List<String> vgenes;

	private static List<String> seqs;

	private List<String> lines;

	public static void main(String[] args) throws Exception {
		///*
		Date date1 = new Date();
		long t1 = date1.getTime();
		//*/
		ClonalRelateClustering clustering = new ClonalRelateClustering();
		clustering.genTest();
		///*
		Date date2 = new Date();
		long t2 = date2.getTime();
		System.out.print(t2-t1);
		System.out.println("ms");
		//*/
		clustering.readTest();
		
		// genTest();
	}

	private void readTest() throws Exception {
		// UPGMAClustering upgmaClustering = new UPGMAClustering();
		// UPGMAClustering upgmaClustering = new UPGMAClustering();
		// String inputFilename = InOutFileName.getInputFilename();
		// readInputCDR(inputFilename);

		Folder folder = loadTree("./dendrogram.xml");
		
		//Use the below code to get maximum disance of a dataset.
		/*
		 * 	
		 List<String> ids = new ArrayList<String>();
		
		//ids.add("5"); ids.add("27"); ids.add("20"); ids.add("19");
		for (int i = 0; i < 90; i++) { 
			// Integer PW57 = seqs.size() - 20 + i;
			ids.add(String.valueOf(seqs.size() - 90 + i));
		}
		// Get the distance that needs to perform cutting
		float dis = getMaxDistance(folder, ids);
		System.out.println(dis);
		*/

		// Distance threshold can be changed here.
		float dis = 0.32f;

		List<Folder> subtrees = cutFolder(folder, dis);
		File path = new File("subtrees/");
		if (!path.exists())
			path.mkdir();
		String pathString = path.getAbsolutePath();
		StringBuffer sb = new StringBuffer();
		List<SortCluster> clusters = new ArrayList<SortCluster>();
		for (int i = 0; i < subtrees.size(); i++) {
			Folder f = subtrees.get(i);
			NodeClassFilter classFilter = new NodeClassFilter(Leaf.NODE_TYPE);
			List<Node> leafnodes = f.extract(classFilter, true);
			List<Integer> seqs = new ArrayList<Integer>();
			for (Node leafnode : leafnodes) {
				if (leafnode instanceof Leaf) {
					Leaf leaf = (Leaf) leafnode;
					String leafId = leaf.get_id();
					if (leafId != null) {
						int seq = -1;
						try {
							seq = Integer.parseInt(leafId);
							seqs.add(seq);
						} catch (Exception e) {
							e.printStackTrace();
						}
					}
				}
			}

			// System.out.println(lines.size());

			for (int n = 0; n < seqs.size(); n++) {
				Integer seqInt = seqs.get(n);
				int seqnum = seqInt.intValue();
				if (seqnum <= lines.size() - 1) {
					/*
					 * sb.append(names.get(seqInt)); sb.append(",");
					 * sb.append(String.valueOf(i)); sb.append(",");
					 * sb.append(String.valueOf(leafnodes.size()));
					 * sb.append(","); sb.append(lines.get(seqInt));
					 * sb.append("\n");
					 */
					String seqString = names.get(seqInt) + ","
							+ String.valueOf(i + 1) + ","
							+ String.valueOf(leafnodes.size()) + ","
							+ lines.get(seqInt).toString();
					Integer clusterId = i;
					SortCluster clusterResult = new SortCluster(seqString,
							clusterId);
					clusters.add(clusterResult);
				}
			}
			// System.out.println(f.getId());
			FileRootNode rootNode = new FileRootNode("root");
			rootNode.makeLogicRoot();
			rootNode.addChildNode(f);
			JDOMPersistenceMgr mgr = JDOMPersistenceMgr.getInstance();
			String filename = pathString + "/" + String.valueOf(i + 1) + ".xml";
			// System.out.println(filename);
			mgr.save(rootNode, filename);
		}
		sortCluster(clusters);

		for (int i = 0; i < clusters.size(); i++) {
			SortCluster clust = clusters.get(i);
			sb.append(clust.getSequenceId());
			if (i < (clusters.size() - 1)) {
				sb.append("\n");
			}
		}
		// System.out.println(subtrees.size());
		try {
			// PrintWriter writer = new PrintWriter(new FileOutputStream(new
			// File("CDR3.txt")));
			/*
			 * String csvPath = pathString+"/" + String.valueOf(i+1)+"/";
			 *  File
			 * file = new File(csvPath); if(!file.exists())file.mkdir();
			 */
			String outputFilename = InOutFileName.getOutputFilename();
			PrintWriter writer = new PrintWriter(outputFilename);
			writer.print(sb.toString());
			writer.flush();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void genTest() {
		// UPGMAClustering upgmaClustering = new UPGMAClustering();
		System.out.println("In put a csv file generalted by FindCDR.java");
		String inputFilename = InOutFileName.getInputFilename();
		
		readInputCDR(inputFilename);
		
		float[][] distanceMatrix = new float[seqs.size()][seqs.size()];
		// System.out.println(seqs.size());
		distanceMatrix = CalculateDM();
		// String outXMLTree = InOutFileName.getOutputFilename();
		getTree(distanceMatrix,"./dendrogram.xml");
	}

	public void sortCluster(List<SortCluster> clusters) {
		if (clusters == null)
			throw new IllegalArgumentException();
		Collections.sort(clusters, SortCluster.getClusterIdComparator());
	}

	public boolean readInputCDR(String inputFilename) {
		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(new File(inputFilename))));
			String input = null;
			// sequenceMap = new ArrayList<List<String>>();
			lines = new ArrayList<String>();
			names = new ArrayList<String>();
			seqs = new ArrayList<String>();
			vgenes = new ArrayList<String>();
			jgenes = new ArrayList<String>();
			while ((input = reader.readLine()) != null) {
				// lines.add(input);
				// System.out.println(lines.size());
				String[] sequenceList = input.split(",");
				String name = sequenceList[0];
				String line = sequenceList[1];
				String vgene = sequenceList[1];
				String jgene = sequenceList[3];
				String sequence = sequenceList[4];
				for (int i = 2; i < sequenceList.length; i++) {
					line = line + "," + sequenceList[i];
				}
				// System.out.println(line);
				seqs.add(sequence);
				lines.add(line);
				vgenes.add(vgene);
				jgenes.add(jgene);
				names.add(name);
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

	public float[][] CalculateDM() {
		float[][] distanceMatrix = new float[names.size()][names.size()];
		System.out.println("Different distance measures are available in DistanceMeasure.java,");
		System.out.println("");
		DistanceMeasure measure = new DistanceMeasure();
		for (int i = 0; i < names.size(); i++) {
			System.out.println(names.get(i));
			String row = seqs.get(i);
			String vrow = vgenes.get(i);
			String jrow = jgenes.get(i);
			

			for (int j = 0; j < names.size(); j++) {
				if (j < i) {
					String col = seqs.get(j);
					String vcol = vgenes.get(j);
					String jcol = jgenes.get(j);
/*					if ((vrow.length()>10) && (vcol.length() >10)) {
					distanceMatrix[i][j] = (float) ((measure.LD(row, col)+ measure.VMatrix(vrow, vcol)
							+ measure.JMatrix(jrow, jcol)) / Math
							.sqrt(Math.max(row.length(), col.length())));
					}
					if ((vrow.length()<=10) || (vcol.length() <=10)) {
						if (!vrow.equals(vcol)){
						distanceMatrix[i][j] = (float) ((measure.LD(row, col)+ 5
								+ measure.JMatrix(jrow, jcol)) / Math
								.sqrt(Math.max(row.length(), col.length())));
					}
						else{
							distanceMatrix[i][j] = (float) ((measure.LD(row, col)
									+ measure.JMatrix(jrow, jcol)) / Math
									.sqrt(Math.max(row.length(), col.length())));
						}
					}
					*/
					//editing distance and Vgene
					//distanceMatrix[i][j]=(float)(measure.LD(row,col)+measure.VMatrix(vrow,vcol)+measure.JMatrix(jrow,jcol));
					//If (LD+V value+J value)/sqrt(length) is used, use this line
					//distanceMatrix[i][j]=(float)((measure.LD(row,col)+measure.VMatrix(vrow,vcol)+measure.JMatrix(jrow,jcol))/Math.sqrt(Math.max(row.length(), col.length())));
					// If ONLY  LD is used , use this line:
					//distanceMatrix[i][j]=(float) measure.LD(row,col);
					// If LD/sqrt(length) is used, use this line:
					//distanceMatrix[i][j]=(float) (measure.LD(row,col)/Math.sqrt(Math.max(row.length(), col.length())));
					// If (NED+V value+J value)/sqrt(length) is used, use this line
					int[] disVal = measure.NED(row, col);
					distanceMatrix[i][j]= (float)(disVal[0]+measure.VMatrix(vrow, vcol)+measure.JMatrix(jrow, jcol))/disVal[1];
				}
				
				else if (j == i) {
					distanceMatrix[i][j] = 0;
				}
			}
		}
		for (int i = 0; i < seqs.size(); i++) {
			for (int j = 0; j < seqs.size(); j++) {
				if (j > i) {
					distanceMatrix[i][j] = distanceMatrix[j][i];
				}
			}
		}
		return distanceMatrix;
	}

	public List<Folder> cutFolder(Folder folder, float distance) {
		if (folder == null)
			throw new IllegalArgumentException();
		DoubleAttributeFilter parentDistFilter = new DoubleAttributeFilter(
				"_dist", distance, "GT");
		DoubleAttributeFilter distFilter = new DoubleAttributeFilter("_dist",
				distance, "LS_OR_EQ");
		HasParentFilter pFilter = new HasParentFilter(parentDistFilter, false);
		NodeClassFilter classFilter = new NodeClassFilter(Folder.NODE_TYPE);

		AndFilter nodefilter = new AndFilter(classFilter, distFilter);
		AndFilter filter = new AndFilter(nodefilter, pFilter);

		List<Node> nodes = folder.extract(filter, true);
		List<Folder> folders = new ArrayList<Folder>();
		for (Node node : nodes) {
			if (node instanceof Folder) {
				Folder f = (Folder) node;
				folders.add(f);
			} else {
				throw new RuntimeException();
			}
		}
		return folders;
	}

	public float getMaxDistance(Folder folder, List<String> ids) {
		List<NodeBeanFilter> orFilters = new ArrayList<NodeBeanFilter>();
		NodeClassFilter classFilter = new NodeClassFilter(Leaf.NODE_TYPE);
		// filters.add(classFilter);
		for (String id : ids) {
			HasAttributeFilter filter = new HasAttributeFilter("_id", id);
			orFilters.add(filter);
		}
		OrFilter idsFilter = new OrFilter(orFilters
				.toArray(new NodeBeanFilter[0]));
		AndFilter andFilter = new AndFilter(classFilter, idsFilter);
		List<Node> nodes = folder.extract(andFilter, true);
		//float max_dist = 0.0f;
		List<List<Node>> paths = new ArrayList<List<Node>>();
		for (Node node : nodes) {
			List<Node> parents = node.getParentNodeList(true);
			paths.add(parents);
		}
		boolean commonParent = true;
		Node commonPNode = null;
		int i = 0;
		while (true) {
			// List<Node> nodelist = paths.get(0);
			Node compNode = null;
			NodeId compNodeId = null;
			for (int j = 0; j < paths.size(); j++) {
				List<Node> nodelist = paths.get(j);
				if (i >= nodelist.size()) {
					commonParent = false;
					break;
				}
				Node tmpNode = nodelist.get(i);
				NodeId nodeId = tmpNode.getId();
				if (compNodeId == null) {
					compNode = tmpNode;
					compNodeId = nodeId;
				} else {
					if (!compNodeId.equals(nodeId)) {
						commonParent = false;
						break;
					}
				}

			}
			if (!commonParent) {
				break;
			} else {
				commonPNode = compNode;
			}
			i++;
		}
		if (commonPNode != null) {
			if (commonPNode instanceof Folder) {
				Folder pFolder = (Folder) commonPNode;
				return pFolder.get_dist();
			}
		}
		return -1.0f;
	}

	public Folder loadTree(String filename) {
		if (filename == null)
			throw new IllegalArgumentException();
		File file = new File(filename);
		if (!file.exists())
			throw new RuntimeException();
		JDOMPersistenceMgr mgr = JDOMPersistenceMgr.getInstance();
		Node node = mgr.loadStandalone(filename);
		Folder folder = null;
		if (node != null) {
			Collection<Node> childList = node.getAllChildNode();
			if (childList.size() > 0) {
				Node[] nodeArray = childList.toArray(new Node[0]);
				Node folderNode = nodeArray[0];
				if (folderNode instanceof Folder) {
					folder = (Folder) folderNode;
				}
			}
		}
		return folder;
	}

	public boolean getTree(float[][] dMatrix,  String outXMLTree) {
		Folder folder = UPGMATreeGenerator.generateTree(dMatrix);
		FileRootNode rootNode = new FileRootNode("root");
		rootNode.makeLogicRoot();
		rootNode.addChildNode(folder);
		JDOMPersistenceMgr mgr = JDOMPersistenceMgr.getInstance();
		return mgr.save(rootNode, outXMLTree);

	}

}
