package clustering;

public class DistanceMeasure {
	public int VMatrix(String x, String y) {
		/*
		 * Example of V gene:IGHV3-72*01_(L1) or IGHV3-30-3*01_(L1) 
		 * IGHV3 - Vgene family;
		 * 72 - V gene name;
		 * 01 - V gene allele;
		 * (L1) - confidencelevel
		 */
		int vvalue = 0;
		if ((x.length() >10) && (y.length()>10)){
		String[] xVinput = x.split("[-\\*_]"); // split V gene into gene name
		// and alleles
		int xsize = xVinput.length;
		String xVfam = xVinput[0];
		String xVname = xVinput[xsize - 2];
		String xVallele = xVinput[xsize - 3];
		// V gene allele
		// Handle with another V gene input
		String[] yVinput = y.split("[-\\*_]");
		int ysize = yVinput.length;
		String yVfam = yVinput[0];
		String yVname = yVinput[ysize - 2];
		String yVallele = yVinput[ysize - 3];

		if (xVfam.equals(yVfam)) {
			if (xVname.equals(yVname)) {
				if (xVallele.equals(yVallele)) {
					vvalue = 0;
					if (!xVallele.equals(yVallele)) {
						vvalue = 1;
					}

				} else {
					vvalue = 3;
				}
			}
		} else {
			vvalue = 5;
		}
		}
		if ((x.length()<=10) || (y.length() <=10)){
			if (!x.equals(y)){
				vvalue = 5;
			}
			else{
				vvalue = 0;
			}
		}
		return vvalue;
	}

	public int JMatrix(String x, String y) {
		/*
		 * Example of J gene:,X86355_IGHJ5*02 IGHV5 - J gene name 02 - V gene
		 * allele
		 */
		int jvalue = 0;
		String[] xJgene = x.split("[_\\*]"); // split J gene into gene
		// name and
		// alleles
		String xJname = xJgene[xJgene.length-2];
		String xJallele = xJgene[xJgene.length-1];
		String[] yJgene = y.split("[_\\*]");
		String yJname = yJgene[yJgene.length-2];
		String yJallele = yJgene[yJgene.length-1];
		if (xJname == yJname) {
			if (xJallele == yJallele) {
				jvalue = 0;
			} else {
				jvalue = 1;
			}
		} else {
			jvalue = 3;
		}
		return jvalue;
	}

	public int[] SLOW_NED(String s, String t) {
		int d[][]; // matrix
		int n; // length of s
		int m; // length of t
		int i; // iterates through s
		int j; // iterates through t
		int cost; // cost
		// Step 1
		n = s.length();
		m = t.length();
		int[] results = new int[2];
		int[][] pointerMatrix = new int[m + 1][n + 1];
		d = new int[m + 1][n + 1];
		// Step 2 Initialize
		for (i = 0; i <= m; i++) {
			d[i][0] = i;
			pointerMatrix[i][0] = 2;
		}
		for (j = 0; j <= n; j++) {
			d[0][j] = j;
			pointerMatrix[0][j] = 3;
		}
		pointerMatrix[0][0] = 0;
		// Step 3
		for (i = 1; i <= m; i++) {
			// Step 4
			for (j = 1; j <= n; j++) {
				String s_i = Character.toString(s.charAt(j - 1));
				String t_j = Character.toString(t.charAt(i - 1));
				// Step 5
				if (s_i.equalsIgnoreCase(t_j)) {
					cost = 0;
				} else {
					cost = 1;
				}
				// Step 6 update distance value and pointerMatrix
				int p, q, r;
				p = d[i - 1][j] + 3;
				q = d[i][j - 1] + 3;
				r = d[i - 1][j - 1] + cost;
				d[i][j] = Math.min(Math.min(p, q), r);
				if (d[i][j] == r) { // diag
					pointerMatrix[i][j] = 1;
				} else if (d[i][j] == p) { // top
					pointerMatrix[i][j] = 2;
				} else { // left
					pointerMatrix[i][j] = 3;
				}

			}
		}
		// Step 7 Trace back
		int k = pointerMatrix[m][n];
		int steps = n;
		i = m - 1;
		j = n - 1;
		while (k != 0) {
			if (k == 1) {
				j = j - 1;
				i = i - 1;
			} else if (k == 2) {
				i = i - 1;
				steps = steps + 1;
			} else {
				j = j - 1;
			}

			k = pointerMatrix[i][j];
		}

		// Step 8

		results[0] = d[m][n];
		results[1] = steps;

		return results;

	}
	public int NEW_LD(String s, String t) {
		if (s == null || t == null) {
		    throw new IllegalArgumentException("Strings must not be null");
		  }	
		  int n = s.length(); // length of s
		  int m = t.length(); // length of t
				
		  if (n == 0) {
		    return m;
		  } else if (m == 0) {
		    return n;
		  }

		  int p[] = new int[n+1]; //'previous' cost array, horizontally
		  int d[] = new int[n+1]; // cost array, horizontally
		  int _d[]; //placeholder to assist in swapping p and d

		  // indexes into strings s and t
		  int i; // iterates through s
		  int j; // iterates through t

		  String t_j; // jth character of t
		  String s_i;
		  
		  int cost; // cost

		  for (i = 0; i<=n; i++) {
		     p[i] = i;
		  }
				
		  for (j = 1; j<=m; j++) {
		     t_j = Character.toString(t.charAt(j-1));
		     d[0] = j;
				
		     for (i=1; i<=n; i++) {
		    	 s_i = Character.toString(s.charAt(i-1));
		    	 if (t_j.equalsIgnoreCase(s_i)) {
						cost = 0;
					} else {
						cost = 1;
					}
		        //cost = s.charAt(i-1)==t_j ? 0 : 1;
		        // minimum of cell to the left+1, to the top+1, diagonally left and up +cost				
		        d[i] = Math.min(Math.min(d[i-1]+3, p[i]+3),  p[i-1]+cost);  
		     }
		     // copy current distance counts to 'previous row' distance counts
		     _d = p;
		     p = d;
		     d = _d;
		     
		  } 
				
		  // our last action in the above loop was to switch d and p, so p now 
		  // actually has the most recent cost counts
		  //System.out.println(d);
		  //System.out.println(p);
		  return p[n];


	}
	  public int LD (String s, String t) {
		  int d[][]; // matrix
		  int n; // length of s
		  int m; // length of t
		  int i; // iterates through s
		  int j; // iterates through t
		  //char s_i; // ith character of s
		  //char t_j; // jth character of t
		  int cost; // cost

		    // Step 1

		    n = s.length ();
		    m = t.length ();
		    if (n == 0) {
		      return m;
		    }
		    if (m == 0) {
		      return n;
		    }
		    d = new int[n+1][m+1];

		    // Step 2

		    for (i = 0; i <= n; i++) {
		      d[i][0] = i;
		    }

		    for (j = 0; j <= m; j++) {
		      d[0][j] = j;
		    }

		    // Step 3

		    for (i = 1; i <= n; i++) {

		      String s_i = Character.toString(s.charAt (i - 1));

		      // Step 4

		      for (j = 1; j <= m; j++) {

		      String  t_j = Character.toString(t.charAt (j - 1));

		        // Step 5

		        if (t_j.equalsIgnoreCase(s_i)) {
		          cost = 0;
		        }
		        else {
		          cost = 1;
		        }

		        // Step 6

		        d[i][j] = Math.min(Math.min (d[i-1][j]+3, d[i][j-1]+3), d[i-1][j-1] + cost);

		      }

		    }

		    // Step 7

		    return d[n][m];

		  }



	public int[] NED(String s, String t) {
		//int d[][]; // matrix
		int n; // length of s
		int m; // length of t
		int i; // iterates through s
		int j; // iterates through t
		int cost; // cost
		 String t_j; // jth character of t
		  String s_i;
		// Step 1
		n = s.length();
		m = t.length();
		int[] results = new int[2];
		int[][] pointerMatrix = new int[n + 1][m + 1];
		int p[] = new int[n+1]; //'previous' cost array, horizontally
		  int d[] = new int[n+1]; // cost array, horizontally
		  int _d[]; //placeholder to assist in swapping p and d
		// Step 2 Initialize
		for (i = 0; i <= n; i++) {
			pointerMatrix[i][0] = 2;
			p[i] = i;
		}
		for (j = 0; j <= m; j++) {
			pointerMatrix[0][j] = 3;
		}
		pointerMatrix[0][0] = 0;
		// Step 3
		for (i = 0; i<=n; i++) {
		     p[i] = i;
		  }
		// Step 4~6		
		for (j = 1; j<=m; j++) {
			 t_j = Character.toString(t.charAt(j-1));
		     d[0] = j;
				
		     for (i=1; i<=n; i++) {
		    	 s_i = Character.toString(s.charAt(i-1));
		    	 if (t_j.equalsIgnoreCase(s_i)) {
						cost = 0;
					} else {
						cost = 1;
					}
		        // minimum of cell to the left+1, to the top+1, diagonally left and up +cost				
				int q, w, r;
				q = d[i-1]+3;
				w = p[i]+3;
				r = p[i-1]+cost;
				d[i] = Math.min(Math.min(q, w), r);
				//d[i] = Math.min(Math.min(d[i-1]+3, p[i]+3),  p[i-1]+cost);
				if (d[i] == r) { // diag
					pointerMatrix[i][j] = 1;
				} else if (d[i] == w) { // top
					pointerMatrix[i][j] = 2;
				} else { // left
					pointerMatrix[i][j] = 3;
				}
		     }
		     // copy current distance counts to 'previous row' distance counts
		     _d = p;
		     p = d;
		     d = _d;
		     
		  } 
		// Step 7 Trace back
		int k = pointerMatrix[n][m];
		int steps = m;
		i = n ;
		j = m ;
		while (k != 0) {
			
			if (k == 1) {
				j = j - 1;
				i = i - 1;
			} else if (k == 2) {
				i = i - 1;
				steps = steps + 1;
			} else {
				j = j - 1;
				
			}
			k = pointerMatrix[i][j];
		}
		// Step 8

		results[0] = p[n];
		results[1] = steps;

		return results;

	}
}
