package clustering;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 
 */

/**
 * @author zhiliangc 
 * Uses IGHV and IGHJ repertoire as dictionaries To extract
 *         CDR3 sequences from iHMMune-Align output
 */
public class FindCDR {

	/**
	 * @param args
	 */
	private Map<String, Integer> Vdict;

	private Map<String, Integer> Jdict;

	private ArrayList<List<String>> seqList;

	private ArrayList<List<String>> CDR3list;

/*
 * private static String rootPath;
 * 
 * private String inputFilename; private String outputFilename;
 */

	public static void main(String[] args) {
		System.out.println("FindCDR.java takes the iHMMuneAlign output file as an input,");
		System.out.println("and outputs file containing CDR3 sequence");
		System.out.println("for performing clustering for extracting clonally-related sets.");
		FindCDR findCDR = new FindCDR();
		findCDR = findCDR.getFindCDRHelper(findCDR);

		// or
		// FindCDR findCDR =getFindCDRHelper__2();

		/*
		 * findCDR.getV(); findCDR.getJ(); String inputFilename =
		 * findCDR.getInputFilename(); findCDR.readInput(inputFilename);
		 * findCDR.GetCDR3(); String outputFilename =
		 * findCDR.getOutputFilename(); findCDR.outputCDR3(outputFilename);
		 */
	}

	public FindCDR getFindCDRHelper(FindCDR findCDR) {
		findCDR.getV();
		findCDR.getJ();
		String inputFilename = InOutFileName.getInputFilename();
		findCDR.readInput(inputFilename);
		findCDR.GetCDR3();
		String outputFilename = InOutFileName.getOutputFilename();
		findCDR.outputCDR3(outputFilename);
		return findCDR;
	}

	public FindCDR getFindCDRHelper__2() {
		FindCDR findCDR = new FindCDR();
		findCDR.getV();
		findCDR.getJ();
		String inputFilename = InOutFileName.getInputFilename();
		findCDR.readInput(inputFilename);
		findCDR.GetCDR3();
		String outputFilename = InOutFileName.getOutputFilename();
		findCDR.outputCDR3(outputFilename);
		return findCDR;
	}

/*
 * public static String getRootPath() { if (rootPath != null) return rootPath;
 * 
 * String currentPath = System.getProperty("user.dir", "."); //
 * System.out.println(currentPath); String root = null; if
 * (currentPath.contains("ClonalRelate")) { root = currentPath.substring(0,
 * currentPath.indexOf("ClonalRelate") + "ClonalRelate".length()); } else {
 * throw new RuntimeException(); } // System.out.println(root); rootPath = root;
 * return root; }
 */

	public boolean getV() {
		try {
			// BufferedReader reader = new BufferedReader(new
			// InputStreamReader(System.in));
			// System.
			BufferedReader vreader = new BufferedReader(new InputStreamReader(
					new FileInputStream(new File(InOutFileName.getRootPath()
							+ "/repertoire/IGHV_Repertoire_CDR3.csv"))));
			String vdictinput = null;
			Vdict = new HashMap<String, Integer>();

			while ((vdictinput = vreader.readLine()) != null) {
				// Get repertoire input
				String[] VdictList = vdictinput.split(",");
				// V gene name and confidence level is seperated by "_"
				String[] VGeneName = VdictList[0].split("[_(]");
				// Get V gene name and allele, but not confidence level
				String VGene = VGeneName[0];
				// System.out.println(VGene);
				// Get CDR3 starting sequence length in V
				Integer VSeqLen = Integer.parseInt(VdictList[2]);
				Vdict.put(VGene, VSeqLen);
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

	public boolean getJ() {
		try {
			// BufferedReader reader = new BufferedReader(new
			// InputStreamReader(System.in));
			BufferedReader jreader = new BufferedReader(new InputStreamReader(
					new FileInputStream(new File(InOutFileName.getRootPath()
							+ "/repertoire/IGHJ_Repertoire_CDR3.csv"))));
			String jdictinput = null;
			Jdict = new HashMap<String, Integer>();
			while ((jdictinput = jreader.readLine()) != null) {
				// Get J repertoire input
				String[] JdictList = jdictinput.split(",");
				// Get J gene name and allele
				String JGene = JdictList[0];
				// Get CDR3 ending sequence length in J
				// System.out.println(JGene);
				Integer JSeqLen = Integer.parseInt(JdictList[2]);
				Jdict.put(JGene, JSeqLen);
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

	
/*	public static String getStringFromStdin(String msg){
		String input = null;
		//boolean succ = false;
		while(true){
			try {
				System.out.print(msg);
				BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
				input = reader.readLine();
				if(input==null){
					System.err.println("input should not be null, pls REinput");
					continue;
				}
				//inputFilename  = input.substring(input.indexOf("<")+1,input.indexOf(">")).trim();
				//outputFilename = input.substring(input.indexOf(">")+1).trim();

				return input;
			} catch (Exception e) {
				e.printStackTrace();
			}			
		}
	}
	
	public static String getInputFilename(){
		String msg = "Please key in input filename:";
		return getStringFromStdin(msg);
	}
	
	public static String getOutputFilename(){
		String msg = "Please key in output filename:";
		return getStringFromStdin(msg);
	}*/

	public boolean readInput(String inputFilename) {
		try {
			// BufferedReader reader = new BufferedReader(new
			// InputStreamReader(System.in));
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					new FileInputStream(new File(inputFilename))));
			
			String input = null;
			// sequenceMap = new ArrayList<List<String>>();
			seqList = new ArrayList<List<String>>();
			while ((input = reader.readLine()) != null) {
				String[] inputList = input.replace("\"", "").split(";");
				//String name = inputList[0];
				//inputList[0] = "" + seqList.size() + "$" + name;
				// System.out.println(inputList[1]);
				// System.out.println(inputList.length);
				List<String> iHMMuneOut = Arrays.asList(inputList);
				// Store the iHMMune-align output as an ArrayList
				List<String> tmp = new ArrayList<String>();
				for (String str : iHMMuneOut) {
					tmp.add(str);
				}
				seqList.add(tmp);
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return false;
	}

	public void GetCDR3() {
		CDR3list = new ArrayList<List<String>>();
		// CDR3list = seqList;
		for (int i = 0; i < seqList.size(); i++) {
			//System.out.println(seqList.get(i).size());
			//System.out.println(seqList.get(i).get(0));
			if (!seqList.get(i).get(2).replace("\"", "").equals("NA")) {
				// CDR3list.add(seqList.get(i));
				List<String> CDR3info = seqList.get(i);
				String[] CDR3line = new String[5];
				CDR3line[0] = seqList.get(i).get(0).replace("\"", "");
				System.out.println(CDR3line[0]);
				CDR3line[1] = seqList.get(i).get(1).replace("\"", "");
				CDR3line[2] = seqList.get(i).get(3).replace("\"", "");
				// Get V and J gene name in iHMMune-align output
				String vname = CDR3line[1].split("[_/(]")[0].replace("\"", "");
				// String vname = vnameN.split("$")[1];
				String vline = CDR3line[1].split("/")[0];
				String jname = CDR3line[2].replace("\"", "");
				//System.out.println(jname);
				// Get CDR3 starting and ending sequences according to
				// repertoire
				// dictionary
				String start = null;
				String end = null;
				//System.out.println(seqList.get(i).get(4));
				//System.out.println(Vdict.get(vname));
				start = seqList.get(i).get(4).replace("\"", "").substring((seqList.get(i).get(4).length() - Vdict.get(vname))).replace(".", "");
				end = seqList.get(i).get(8).replace("\"", "").substring(0,
						Jdict.get(jname) + 1).replace(".", "");
				// Join all sequences together to make CDR3 sequence
				String CDR3 = start
						+ seqList.get(i).get(5).replace("\"", "").replace(".",
								"")
						+ seqList.get(i).get(6).replace("\"", "").replace(".",
								"")
						+ seqList.get(i).get(7).replace("\"", "").replace(".",
								"") + end;
				CDR3line[3] = CDR3;
				// CDR3line[3] = CDR3.toUpperCase();
				// System.out.println(CDR3line[3]);
				CDR3line[4] = "" + CDR3line[3].length();
				// CDR3list.add((seqList.get(i).add(4,CDR3line[3])).add(5,CDR3line[4]));
				//System.out.println(CDR3info.toString());
				CDR3info.remove(1);
				CDR3info.add(1, vline);
				CDR3info.add(4, CDR3line[3]);
				CDR3info.add(5, CDR3line[4]);
				CDR3list.add(CDR3info);
				// System.out.println(CDR3list.get(i).toString());
				// CDR3list.get(i).add(CDR3line[3]);
				// System.out.println(CDR3list.get(i).toString());
				// CDR3list.get(i).add(CDR3line[4]);
			}
		}

	}

	public void outputCDR3(String outputFilename) {
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < CDR3list.size(); i++) {

			for (int j = 0; j < CDR3list.get(i).size(); j++) {
				sb.append(CDR3list.get(i).get(j));
				if (j < (CDR3list.get(i).size() - 1)) {
					sb.append(",");
				} else {
					sb.append("\n");
				}
			}
		}
		try {
			// PrintWriter writer = new PrintWriter(new FileOutputStream(new
			// File("CDR3.txt")));
			PrintWriter writer = new PrintWriter(outputFilename);
			writer.print(sb.toString());
			writer.flush();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public Map<String, Integer> getVdict() {
		return Vdict;
	}

	public void setVdict(Map<String, Integer> vdict) {
		Vdict = vdict;
	}

	public Map<String, Integer> getJdict() {
		return Jdict;
	}

	public void setJdict(Map<String, Integer> jdict) {
		Jdict = jdict;
	}

	public ArrayList<List<String>> getSeqList() {
		return seqList;
	}

	public void setSeqList(ArrayList<List<String>> seqList) {
		this.seqList = seqList;
	}

	public ArrayList<List<String>> getCDR3list() {
		return CDR3list;
	}

	public void setCDR3list(ArrayList<List<String>> cdr3list) {
		CDR3list = cdr3list;
	}

}