package clustering;

import clustering.node.Folder;
import clustering.node.Leaf;

// Generate tree using average linkage

public class UPGMATreeGenerator {
	
	public static Folder generateTree(float [][] dDistanceMatrix){
		//String [] XMLTree = new String[dDistanceMatrix.length];
		Folder [] folders = new Folder[dDistanceMatrix.length];
		int[] DataIds = new int [dDistanceMatrix.length];
		for(int i=0;i<dDistanceMatrix.length;i++)DataIds[i]= i ;
		int min_i = -1, min_j = -1;
		int k = 0;
		while(dDistanceMatrix.length > 1){
			double min_dist = Double.MAX_VALUE;
			min_i = -1;
			min_j = -1;
			for(int i=0;i<dDistanceMatrix.length;i++){
				for(int j=i+1;j<dDistanceMatrix.length;j++){
					if(min_dist > dDistanceMatrix[i][j]){
						min_i = i;
						min_j = j;
						min_dist = dDistanceMatrix[i][j];
					}
				}
			}
			
			if(folders[min_i]==null && folders[min_j]==null){
				Folder folder = new Folder();
				folder.makeLogicRoot();
				folder.set_id("-1");
				folder.set_step(k);
				folder.set_dist(dDistanceMatrix[min_i][min_j]);
				Leaf leaf_1 = new Leaf();
				Leaf leaf_2 = new Leaf();
				leaf_1.set_id(String.valueOf(DataIds[min_i]));
				leaf_2.set_id(String.valueOf(DataIds[min_j]));
				
				folder.addChildNode(leaf_1);
				folder.addChildNode(leaf_2);
				
				folders[min_i]=folder;
				//XMLTree[min_i]="<node id=\"-1\" step=\""+k+"\" dist=\""+dDistanceMatrix[min_i][min_j]+"\">";
				//XMLTree[min_i]+="<leaf id=\""+DataIds[min_i]+"\"/>";
				//XMLTree[min_i]+="<leaf id=\""+DataIds[min_j]+"\"/>";
				//XMLTree[min_i]+="</node>";
				//System.out.println(dDistanceMatrix[min_i][min_j]);
			}else if(folders[min_i]!=null && folders[min_j]!=null){
				Folder folder = new Folder();
				folder.makeLogicRoot();
				folder.set_id("-1");
				folder.set_step(k);
				folder.set_dist(dDistanceMatrix[min_i][min_j]);
				
				Folder folder_min_i = folders[min_i];
				Folder folder_min_j = folders[min_j];
				folder.addChildNode(folder_min_i);
				folder.addChildNode(folder_min_j);
				
				folders[min_i]=folder;
				//System.out.println(dDistanceMatrix[min_i][min_j]);
				//XMLTree[min_i]="<node id=\"-1\" step=\""+k+"\" dist=\""+dDistanceMatrix[min_i][min_j]+"\">" + XMLTree[min_i] + XMLTree[min_j] + "</node>";
			}else if(folders[min_i]!=null){
				Folder folder = new Folder();
				folder.makeLogicRoot();
				folder.set_id("-1");
				folder.set_step(k);
				folder.set_dist(dDistanceMatrix[min_i][min_j]);
				Folder folder_min_i = folders[min_i];
				if(folder_min_i.getParent()!=null){
					folder_min_i.getParent().removeChildNode(folder_min_i, false);
				}
				
				folder.addChildNode(folder_min_i);
				Leaf leaf_1 = new Leaf();
				leaf_1.set_id(String.valueOf(DataIds[min_j]));
				folder.addChildNode(leaf_1);
				folders[min_i]=folder;
				//System.out.println(dDistanceMatrix[min_i][min_j]);
				//XMLTree[min_i]="<node id=\"-1\" step=\""+k+"\" dist=\""+dDistanceMatrix[min_i][min_j]+"\">" + XMLTree[min_i];
				//XMLTree[min_i]+="<leaf id=\""+DataIds[min_j]+"\"/>";
				//XMLTree[min_i]+="</node>";
			}else{
				Folder folder = new Folder();
				folder.makeLogicRoot();
				folder.set_id("-1");
				folder.set_step(k);
				folder.set_dist(dDistanceMatrix[min_i][min_j]);
				Folder folder_min_j = folders[min_j];
				if(folder_min_j.getParent()!=null){
					folder_min_j.getParent().removeChildNode(folder_min_j, false);
				}
				
				folder.addChildNode(folder_min_j);
				Leaf leaf_1 = new Leaf();
				leaf_1.set_id(String.valueOf(DataIds[min_i]));
				folder.addChildNode(leaf_1);
				folders[min_i]=folder;
				//System.out.println(dDistanceMatrix[min_i][min_j]);
				//XMLTree[min_i]="<node id=\"-1\" step=\""+k+"\" dist=\""+dDistanceMatrix[min_i][min_j]+"\">" + XMLTree[min_j];
				//XMLTree[min_i]+="<leaf id=\""+DataIds[min_i]+"\"/>";
				//XMLTree[min_i]+="</node>";
			}
			
			for(int i=min_j+1;i<folders.length;i++){
				folders[i-1] = folders[i];
				//XMLTree[i-1] = XMLTree[i];
				DataIds[i-1] = DataIds[i];
			}
		
			float [][] dTempMatrix = new float[dDistanceMatrix.length-1][dDistanceMatrix.length-1];
			for(int i=0;i<dDistanceMatrix.length;i++){
				for(int j=i+1;j<dDistanceMatrix.length;j++){
					if(i==min_i){
						if(j < min_j){
							dTempMatrix[min_i][j] = (dDistanceMatrix[min(min_i,j)][max(min_i,j)] + dDistanceMatrix[min(min_j,j)][max(min_j,j)])/2;
						}else if(j > min_j){
							dTempMatrix[min_i][j-1] = (dDistanceMatrix[min(min_i,j)][max(min_i,j)] + dDistanceMatrix[min(min_j,j)][max(min_j,j)])/2;
						}
					}else if(i != min_j){
						if(j < min_j){
							if(i < min_j){
								dTempMatrix[i][j] = dDistanceMatrix[i][j];
							}else{
								dTempMatrix[i-1][j] = dDistanceMatrix[i][j];
							}
						}else if(j > min_j){
							if(i < min_j){
								dTempMatrix[i][j-1] = dDistanceMatrix[i][j];
							}else{
								dTempMatrix[i-1][j-1] = dDistanceMatrix[i][j];
							}
						}						
					}
				}
			}
			dDistanceMatrix = dTempMatrix;
			k++;
		}		
		return folders[min_i];
	}
	
	public static int min(int a, int b){
		if(a > b)return b;
		return a;
	}
	public static int max(int a, int b){
		if(a < b)return b;
		return a;
	}
}
