package com.giantleap.common.nodebean.node.base.filter;

import com.giantleap.common.nodebean.node.base.storage.node.Node;
import com.giantleap.common.nodebean.node.base.storage.node.NodeImp;
import com.giantleap.common.nodebean.node.base.storage.node.Property;

public class ContainsAttributeFilter  implements NodeBeanFilter{
	protected String _attribute;

	/**
	 * The value to check for.
	 */
	protected String _value;

	public ContainsAttributeFilter() {
		this("", null);
	}

	/**
	 * Creates a new instance of HasAttributeFilter that accepts tags with the
	 * given attribute.
	 * 
	 * @param attribute
	 *            The attribute to search for.
	 */
	public ContainsAttributeFilter(String attribute) {
		this(attribute, null);
	}

	public ContainsAttributeFilter(String attribute, String value) {
		_attribute = attribute;
		_value = value;
	}

	public String getAttributeName() {
		return (_attribute);
	}

	public void setAttributeName(String name) {
		_attribute = name;
	}

	public String getAttributeValue() {
		return (_value);
	}

	public void setAttributeValue(String value) {
		_value = value;
	}

	public boolean accept(Node node) {
		NodeImp nodeimp;
		Property attribute;
		//boolean ret;

		//ret = false;
		if (node instanceof NodeImp) {
			nodeimp = (NodeImp) node;
			attribute = nodeimp.getProperty(_attribute);
			//System.out.println(mAttribute+"::"+nodeimp.getProperty(mAttribute));
			if (attribute == null)return false;
			if (_value == null)   return true;

			return _value.trim().toUpperCase().contains(attribute.getString().toUpperCase());
		}
		return false;
	}
}
