package com.giantleap.common.nodebean.node.base.filter;

import com.giantleap.common.nodebean.node.base.storage.node.Node;
import com.giantleap.common.nodebean.node.base.storage.node.NodeImp;
import com.giantleap.common.nodebean.node.base.storage.node.Property;
import com.giantleap.common.nodebean.node.base.storage.value.IllegalValueException;
import com.giantleap.common.nodebean.node.base.storage.value.Value;

public class DoubleAttributeFilter  implements NodeBeanFilter {
	protected String mAttribute;

	/**
	 * The value to check for.
	 */
	//protected String mValue;
	
	protected double _value;
	protected String _compare="GT";
	
	public DoubleAttributeFilter() {
		this("", 0.0d);
	}

	/**
	 * Creates a new instance of HasAttributeFilter that accepts tags with the
	 * given attribute.
	 * 
	 * @param attribute
	 *            The attribute to search for.
	 */
	public DoubleAttributeFilter(String attribute) {
		this(attribute, 0.0d);
	}

	public DoubleAttributeFilter(String attribute, double value) {
		mAttribute = attribute;
		_value = value;
	}
	public DoubleAttributeFilter(String attribute, double value,String compare) {
		mAttribute = attribute;
		_value     = value;
		_compare   = compare;
	}
	
	public String getAttributeName() {
		return (mAttribute);
	}



	public double getAttributeValue() {
		return (_value);
	}


	public String get_compare() {
		return _compare;
	}

	public boolean accept(Node node) {
		NodeImp nodeimp;
		Property attribute;
		//boolean ret;

		//ret = false;
		if (node instanceof NodeImp) {
			nodeimp = (NodeImp) node;
			attribute = nodeimp.getProperty(mAttribute);
				if (attribute == null)return false;
				//if (mValue == null)   return true;
				Value v = attribute.getValue();
				double doubleValue=0.0d;
				try {
					doubleValue = v.getDouble();
				} catch (IllegalValueException e) {
					return false;
				}

				if(_compare.equalsIgnoreCase("GT")){
					if(doubleValue > _value) return true;
					return false;
				}else if(_compare.equalsIgnoreCase("GT_OR_EQ")){
					if(doubleValue >= _value) return true;
					return false;				
				}else if(_compare.equalsIgnoreCase("LS_OR_EQ")){
					if(doubleValue <= _value) return true;
					return false;						
				}else{
					if(doubleValue < _value) return true;
					return false;						
				}
				
		}
		return false;
	}
}
