package com.giantleap.common.nodebean.node.base.filter;

import com.giantleap.common.nodebean.node.base.storage.node.Node;
import com.giantleap.common.nodebean.node.base.storage.node.NodeImp;
import com.giantleap.common.nodebean.node.base.storage.node.Property;

public class HasAttributeFilter implements NodeBeanFilter {
	protected String mAttribute;

	/**
	 * The value to check for.
	 */
	protected String mValue;

	public HasAttributeFilter() {
		this("", null);
	}

	/**
	 * Creates a new instance of HasAttributeFilter that accepts tags with the
	 * given attribute.
	 * 
	 * @param attribute
	 *            The attribute to search for.
	 */
	public HasAttributeFilter(String attribute) {
		this(attribute, null);
	}

	public HasAttributeFilter(String attribute, String value) {
		mAttribute = attribute;
		mValue = value;
	}

	public String getAttributeName() {
		return (mAttribute);
	}

	public void setAttributeName(String name) {
		mAttribute = name;
	}

	public String getAttributeValue() {
		return (mValue);
	}

	public void setAttributeValue(String value) {
		mValue = value;
	}

	public boolean accept(Node node) {
		NodeImp nodeimp;
		Property attribute;
		//boolean ret;

		//ret = false;
		if (node instanceof NodeImp) {
			nodeimp = (NodeImp) node;
			attribute = nodeimp.getProperty(mAttribute);
			if(!mAttribute.equals(Node.ID_PROPERTY_LITERAL)){
				if (attribute == null)return false;
				if (mValue == null)   return true;

				return mValue.trim().equalsIgnoreCase(attribute.getString());
			}else{
				return mValue.trim().equals(nodeimp.getId().toString());
			}
			//System.out.println(mAttribute+"::"+nodeimp.getProperty(mAttribute));

		}
		return false;
	}
}
