package com.giantleap.common.nodebean.node.base.filter;

import java.util.Collection;

import com.giantleap.common.nodebean.node.base.storage.node.Node;

public class HasChildFilter implements NodeBeanFilter {
	protected NodeBeanFilter _childFilter;
	protected boolean _recursive;

	public HasChildFilter() {
		this(null);
	}

	public HasChildFilter(NodeBeanFilter filter) {
		this(filter, false);
	}

	public HasChildFilter(NodeBeanFilter filter, boolean recursive) {
		set_childFilter(filter);
		set_recursive(recursive);
	}

	public NodeBeanFilter get_childFilter() {
		return _childFilter;
	}

	public boolean is_recursive() {
		return _recursive;
	}

	public void set_childFilter(NodeBeanFilter filter) {
		_childFilter = filter;
	}

	public void set_recursive(boolean _recursive) {
		this._recursive = _recursive;
	}

	public boolean accept(Node node) {
		boolean ret = false;
		Collection<Node> children = node.getAllChildNode();
		if (children != null) {
			for (Node cnode : children) {
				if (get_childFilter().accept(cnode)) {
					ret = true;
					break;
				}
			}
			if (ret == false && is_recursive())
				for (Node cnode : children) {
					if (accept(cnode)) {
						ret = true;
						break;
					}
				}

		}

		return ret;
	}
}
