package com.giantleap.common.nodebean.node.base.filter;

import com.giantleap.common.nodebean.node.base.storage.node.Node;
import com.giantleap.common.nodebean.node.base.storage.node.NodeImp;

public class HasIdFilter implements NodeBeanFilter {
	protected String mAttribute;

	/**
	 * The value to check for.
	 */
	protected String mValue;

	public HasIdFilter(String id) {
		this(Node.ID_PROPERTY_LITERAL, id);
	}


	private HasIdFilter(String attribute, String value) {
		mAttribute = attribute;
		mValue = value;
	}

	public String getAttributeName() {
		return (mAttribute);
	}

	public void setAttributeName(String name) {
		mAttribute = name;
	}

	public String getAttributeValue() {
		return (mValue);
	}

	public void setAttributeValue(String value) {
		mValue = value;
	}

	public boolean accept(Node node) {
		NodeImp nodeimp;
		//Property attribute;
		//boolean ret;

		//ret = false;
		if (node instanceof NodeImp) {
			nodeimp = (NodeImp) node;
			String id = nodeimp.getId().toString();
			//System.out.println(mAttribute+"::"+nodeimp.getProperty(mAttribute));
			//if (attribute == null)return false;
			if (mValue == null)   return true;

			return mValue.trim().toUpperCase().equals(id.toUpperCase());
		}
		return false;
	}
}
