package com.giantleap.common.nodebean.node.base.filter;

import com.giantleap.common.nodebean.node.base.storage.node.Node;

public class HasParentFilter  implements NodeBeanFilter{
	protected NodeBeanFilter _parentFilter;
	protected boolean _recursive;
	
	public HasParentFilter() {
		this(null);
	}
	public HasParentFilter(NodeBeanFilter filter) {
		this(filter, false);
	}
	public HasParentFilter(NodeBeanFilter filter, boolean recursive) {
		set_parentFilter(filter);
		set_recursive(recursive);
	}

	public NodeBeanFilter get_parentFilter() {
		return _parentFilter;
	}
	public void set_parentFilter(NodeBeanFilter filter) {
		_parentFilter = filter;
	}
	public boolean is_recursive() {
		return _recursive;
	}

	public void set_recursive(boolean _recursive) {
		this._recursive = _recursive;
	}
	
	public boolean accept(Node node) {
		boolean ret = false;
		Node parent = node.getParent();
		if(parent==null)return false;
		if(get_parentFilter()==null)return true;
		ret = get_parentFilter().accept(parent);
		if(!ret&&is_recursive()){
			ret = accept(parent);
		}

		return ret;
	}
}
