package com.giantleap.common.nodebean.node.base.filter;

import com.giantleap.common.nodebean.node.base.storage.node.Node;
import com.giantleap.common.nodebean.nodeCollection.NodeCollections;

public class NodeClassHierarchyFilter implements NodeBeanFilter{
	protected String _className;
	public NodeClassHierarchyFilter() {
		this("");
	}

	public NodeClassHierarchyFilter(String name) {
		_className = name.toUpperCase();
	}

	public String get_className() {
		return (_className);
	}

	public void setName(String name) {
		_className = name;
	}
	
	public boolean accept(Node node) {
		String classname=NodeCollections.getJavaClassName(get_className());
		if(classname==null)return false;
		Class nodeClass=node.getClass();
		
		try{
			Class classDefinition = Class.forName(classname);
			//System.out.println(node.getClass().equals(classDefinition));
		    Class superclass = nodeClass;
		    while (superclass != null) {
				//System.out.println(superclass.toString());
				//System.out.println(superclass.equals(classDefinition));
		    	if(superclass.equals(classDefinition))return true;
		    	superclass = superclass.getSuperclass();

		    }
		}catch(Exception e){
			e.printStackTrace();
		}
		return false;
		
		

	}
	public static void main(String[] args)throws Exception{
		NodeClassHierarchyFilter filter=new NodeClassHierarchyFilter("HeadNavModule");
		//GL6Module node=new GL6Module("dsfsda");
		//filter.accept(node);
	}
	
}
