package com.giantleap.common.nodebean.node.base.filter;

import java.util.Collection;

import com.giantleap.common.nodebean.node.base.storage.node.Node;

public class NotHasChildFilter implements NodeBeanFilter {
	protected NodeBeanFilter _childFilter;

	// protected boolean _recursive;

	public NotHasChildFilter() {
		this(null);
	}

	public NotHasChildFilter(NodeBeanFilter filter) {
		_childFilter = filter;
	}

	public NodeBeanFilter get_childFilter() {
		return _childFilter;
	}

	public void set_childFilter(NodeBeanFilter filter) {
		_childFilter = filter;
	}

	public boolean accept(Node node) {
		boolean ret = true;
		Collection<Node> children = node.getAllLogicChildNode();
		if (children != null) {
			for (Node cnode : children) {
				if (get_childFilter().accept(cnode)) {
					ret = false;
					break;
				}
			}

		}

		return ret;
	}
}
