package com.giantleap.common.nodebean.node.base.storage.node;

import com.giantleap.common.nodebean.node.base.storage.path.NameImp;
import com.giantleap.common.nodebean.node.base.storage.path.NameInterface;
import com.giantleap.common.nodebean.node.base.storage.path.PathElement;
import com.giantleap.common.nodebean.node.base.storage.path.PathImp;
import com.giantleap.common.nodebean.node.base.storage.path.PathInterface;
import com.giantleap.common.nodebean.node.base.storage.path.exception.IllegalNameException;

public abstract class ItemImp implements Item{

	protected Node parent;
	protected NameInterface name;
	protected PathInterface path;

	
	protected ItemImp(String name_){
		NameInterface n=null;
		try{
			n=NameImp.createName(name_);
		}catch(IllegalNameException e){
			throw new IllegalArgumentException();
		}
		name=n;
	}
	
	protected ItemImp(NameInterface name_){
		name=name_;
	}

	public PathInterface getPath(){
		return path;
	}

	public NameInterface getName(){
		return name;		
	}
	
	public void setParentNull(){
		parent=null;
		path=PathInterface.ROOT_PATH;
	}
	
	public Item setParent(Node pnode){
		parent=pnode;
		setPath(pnode);
		return this;
	}
	
	public Node getRoot(){
		Item p = this;
		while(p.getParent()!=null){
			p=p.getParent();
		}
		if(p instanceof Node){
			Node q=(Node)p;
			return q;
		}
		return null;
	}
	
	public Node getParent(){
		return parent;
	}
	
	public PathInterface setPath(Node parent){
		if(parent==null)  throw new IllegalArgumentException("null");
		int index=parent.getChildNameCount(name);
		PathInterface nodepath=null;
		try{
			PathInterface parentPath=parent.getPath();
			nodepath=PathImp.createPath(parentPath,name,index+PathElement.INDEX_DEFAULT,true);				
			if(nodepath!=null) path=nodepath;
		}catch(IllegalNameException e){
			e.printStackTrace();		
		}
		return nodepath;
	}
	
	public void setPath(PathInterface p){
		//System.out.println(p.getString());
		path=p;
	}
	

}
