package com.giantleap.common.nodebean.node.base.storage.node;


import com.giantleap.common.exception.GLException;
import com.giantleap.common.nodebean.node.base.storage.path.NameImp;
import com.giantleap.common.nodebean.node.base.storage.path.NameInterface;
import com.giantleap.common.nodebean.node.base.storage.value.IllegalValueException;
import com.giantleap.common.nodebean.node.base.storage.value.Value;
import com.giantleap.common.nodebean.node.base.storage.value.ValueFactoryImp;

public class PropertyImp extends ItemImp implements Property{
	//cannot be null
	private Value _value;
	
	PropertyImp(String name,Value value){
		super(name);
		_value=value;
	}
	
	PropertyImp(NameInterface name,Value value){
		super(name);
		_value=value;
	}
	
	PropertyImp(NameInterface name,String valueString,String type)throws IllegalValueException{
		super(name);
		Value value=ValueFactoryImp.createValue(valueString, type);
		_value=value;
	}
	
	PropertyImp(NameInterface name,String valueString,int type)throws IllegalValueException{
		super(name);
		Value value=ValueFactoryImp.createValue(valueString, type);
		_value=value;
	}

	public static Property create(String name,Value value){
		if(name==null||value==null)  throw new IllegalArgumentException("null");
		return new PropertyImp(name,value);
	}
	
	public static Property create(NameInterface name,Value value){
		if(name==null||value==null)  throw new IllegalArgumentException("null");
		return new PropertyImp(name,value);
	}
	
	public static Property create(NameInterface name,String valuestr,int type)throws IllegalValueException{
		if(name==null||valuestr==null)  throw new IllegalArgumentException("null");
		return new PropertyImp(name,valuestr,type);
	}
	
	public static Property create(NameInterface name,String valuestr,String type)throws IllegalValueException{
		if(name==null||valuestr==null)  throw new IllegalArgumentException("null");

		return new PropertyImp(name,valuestr,type);
	}
	public static Property create(String name,String valuestr,String type)throws IllegalValueException{
		if(name==null||valuestr==null)  throw new IllegalArgumentException("null");
		NameInterface n=null;
		try{
			n=NameImp.createName(name);
		}catch(GLException e){
			return null;
		}		
		return create(n,valuestr,type);
	}
	
	public static Property create(String name,String valuestr,int type)throws IllegalValueException{
		if(name==null||valuestr==null)  throw new IllegalArgumentException("null");
		NameInterface n=null;
		try{
			n=NameImp.createName(name);
		}catch(GLException e){
			return null;
		}		
		return create(n,valuestr,type);
	}
	
    public void setValue(Value value){
    	_value=value;
    }
    
    
    
    public void setValue(String valueStr,int type)throws IllegalValueException{
    	if(valueStr==null) throw new IllegalArgumentException("null value");    	
    	Value value=ValueFactoryImp.createValue(valueStr, type);
    	
		setValue(value);
    }
    
    public Value getValue(){
    	return _value;
    }
    
    public String getString(){
    	try{
    		return _value.getString();
    	}catch(GLException e){
    		e.printStackTrace();
    		return null;
    	}
    	
    }
	
	public boolean isNode(){
		return false;
	}
	

	public int getValueType(){
		return _value.getType();
	}
	
	public void updateChildPath(boolean recursive){
		
	}
	
	public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj instanceof PropertyImp) {
        	PropertyImp property = (PropertyImp)obj;
        	return property.getValue().equals(this.getValue());
        }
        return false;
	}
	
}
