package com.giantleap.common.nodebean.node.base.storage.value;

import java.util.ArrayList;
import java.util.List;

public class ArrayListValue  extends BaseValue{
    public static final int TYPE = PropertyType.ARRAYLIST_STRING;

    public static final String SPERATOR="#,#";
    
    private List<String> _data= new ArrayList<String>();

    /**
     * Constructs a <code>StringValue</code> object representing a string.
     *
     * @param text the string this <code>StringValue</code> should represent
     */
    public ArrayListValue(String text) {
        super(TYPE);
        _data=strToList(text,null);
    }
    
    public static List<String> strToList(String text,String seperator){
    	List<String> data= new ArrayList<String>();
    	String[] items=null;
    	if(seperator==null){
    		items=text.split(SPERATOR);
        }else{
        	items=text.split(seperator);
        }
        //_text 
        for(String str:items){
        	data.add(str);
        }
        return data;
    }
    
    public static String listToStr(List<String> text,String seperator){
    	StringBuffer sb=new StringBuffer();
        for(int i=0;i<text.size();i++){
        	String data=text.get(i);
        	sb.append(data);
        	if(i<text.size()-1){
            	if(seperator==null){
            		sb.append(SPERATOR);
                }else{
                	sb.append(seperator);
                }
        	}
        }
        return sb.toString();
    }
    
    public ArrayListValue(List<String> text) {
        super(TYPE);
        this._data = text;
    }
    
    
    public List<String> get_data() {
		return _data;
	}

	public void set_data(List<String> _data) {
		this._data = _data;
	}
	
	

	/**
     * Indicates whether some other object is "equal to" this one.
     * <p/>
     * The result is <code>true</code> if and only if the argument is not
     * <code>null</code> and is a <code>StringValue</code> object that
     * represents the same value as this object.
     *
     * @param obj the reference object with which to compare.
     * @return <code>true</code> if this object is the same as the obj
     *         argument; <code>false</code> otherwise.
     */
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj instanceof ArrayListValue) {
        	ArrayListValue other = (ArrayListValue) obj;
        	
        	for(String str:_data){
        		if(!(other).get_data().contains(str)){
        			return false;
        		}
        	}
        	return true;
        }
        return false;
    }

    /**
     * Returns zero to satisfy the Object equals/hashCode contract.
     * This class is mutable and not meant to be used as a hash key.
     *
     * @return always zero
     * @see Object#hashCode()
     */
    public int hashCode() {
        return _data.hashCode();
    }

    //------------------------------------------------------------< BaseValue >
    /**
     * {@inheritDoc}
     */
    protected String getInternalString() throws IllegalValueException {
        if (_data != null) {
            return listToStr(_data,null);
        } else {
            throw new IllegalValueException("empty value");
        }
    }
}
