package com.giantleap.common.nodebean.node.base.storage.value;


import java.util.HashSet;
import java.util.Set;

public class StringSetValue  extends BaseValue{
    public static final int TYPE = PropertyType.SET_STRING;

    public static final String SPERATOR="#,#";
    
    private Set<String> _data= new HashSet<String>();

    /**
     * Constructs a <code>StringValue</code> object representing a string.
     *
     * @param text the string this <code>StringValue</code> should represent
     */
    public StringSetValue(String text) {
        super(TYPE);
        _data=strToSet(text,null);
    }
    
    public static Set<String> strToSet(String text,String seperator){
    	Set<String> data= new HashSet<String>();
    	String[] items=null;
    	if(seperator==null){
    		items=text.split(SPERATOR);
        }else{
        	items=text.split(seperator);
        }
        //_text 
        for(String str:items){
        	data.add(str);
        }
        return data;
    }
    
    public static String setToStr(Set<String> text,String seperator){
    	StringBuffer sb=new StringBuffer();
    	int i=0;
        for(String data:text){
        	sb.append(data);
        	if(i<text.size()-1){
            	if(seperator==null){
            		sb.append(SPERATOR);
                }else{
                	sb.append(seperator);
                }
        	}
        	i++;
        }
        return sb.toString();
    }
    
    public StringSetValue(Set<String> text) {
        super(TYPE);
        this._data = text;
    }
    
    
    public Set<String> get_data() {
		return _data;
	}

	public void set_data(Set<String> _data) {
		this._data = _data;
	}
	
	

	/**
     * Indicates whether some other object is "equal to" this one.
     * <p/>
     * The result is <code>true</code> if and only if the argument is not
     * <code>null</code> and is a <code>StringValue</code> object that
     * represents the same value as this object.
     *
     * @param obj the reference object with which to compare.
     * @return <code>true</code> if this object is the same as the obj
     *         argument; <code>false</code> otherwise.
     */
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj instanceof StringSetValue) {
        	StringSetValue other = (StringSetValue) obj;
        	if(other.get_data().size()!=_data.size())return false;
        	for(String str:_data){
        		if(!(other).get_data().contains(str)){
        			return false;
        		}
        	}
        	return true;
        }
        return false;
    }

    /**
     * Returns zero to satisfy the Object equals/hashCode contract.
     * This class is mutable and not meant to be used as a hash key.
     *
     * @return always zero
     * @see Object#hashCode()
     */
    public int hashCode() {
        return _data.hashCode();
    }

    //------------------------------------------------------------< BaseValue >
    /**
     * {@inheritDoc}
     */
    protected String getInternalString() throws IllegalValueException {
        if (_data != null) {
            return setToStr(_data,null);
        } else {
            throw new IllegalValueException("empty value");
        }
    }

}
