package com.giantleap.common.nodebean.node.root;

import com.giantleap.common.nodebean.node.base.ReflectionNode;
import com.giantleap.common.nodebean.node.base.storage.id.NodeId;
import com.giantleap.common.nodebean.node.base.storage.path.NameInterface;
import com.giantleap.common.nodebean.node.base.storage.path.PathInterface;
import com.giantleap.common.nodebean.repository.TreeRepository;

public abstract class AbstractRootNode extends ReflectionNode implements RootNodeInterface{
	public static final String NODE_TYPE = "_TP_AbstractRootNode";
	public static final String DEFAULT_NODE_NAME = "AbstractRootNode";

	//must be set when initiallized or loaded
	private String uri;
	private String persistenceMgr;
	
	public AbstractRootNode(String n) {
		this(n, NODE_TYPE);
	}

	// for extended classes
	public AbstractRootNode(String n, String nodetype) {
		super(n, nodetype);
	}

	// for valueOf
	public AbstractRootNode(NameInterface n, NodeId id) {
		super(n, id);
	}
	
	public boolean save(){
		TreeRepository treeRep = TreeRepository.getInstance();
		return treeRep.save(this);
	}
	
	public boolean save(String uri){
		TreeRepository treeRep = TreeRepository.getInstance();
		return treeRep.save(this,uri);
	}
	
	public abstract String getParentURI();
	
	public NodeId getTreeId(){
		return this.getId();
	}
	
	public void makeLogicRoot(){
		this.setPath(PathInterface.ROOT_PATH);
	}
	
	public String getUri() {
		return uri;
	}

	public void setUri(String uri) {
		this.uri = uri;
	}
	
	public String getPersistenceMgr() {
		return persistenceMgr;
	}

	public void setPersistenceMgr(String persistenceMgr) {
		this.persistenceMgr = persistenceMgr;
	}

	
	
	public String getType() {
		return NODE_TYPE;
	}
}
