package com.giantleap.common.nodebean.node.root.file;

import com.giantleap.common.nodebean.node.base.storage.id.NodeId;
import com.giantleap.common.nodebean.node.base.storage.path.NameInterface;
import com.giantleap.common.nodebean.node.root.AbstractRootNode;

public class FileRootNode extends AbstractRootNode{
	public static final String NODE_TYPE = "_TP_FileRootNode";
	public static final String DEFAULT_NODE_NAME = "FileRootNode";

	public FileRootNode() {
		this(DEFAULT_NODE_NAME);
	}
	public FileRootNode(String n) {
		this(n, NODE_TYPE);
	}

	// for extended classes
	public FileRootNode(String n, String nodetype) {
		super(n, nodetype);
	}

	// for valueOf
	public FileRootNode(NameInterface n, NodeId id) {
		super(n, id);
	}

	public String getParentURI(){
		String uri = this.getUri();
		if(uri==null)return null;
		uri=uri.trim();
		uri=uri.replace('\\', '/');
		String parentURI=null;
		if(uri.contains("/")){
			int pos = uri.lastIndexOf("/");
			if(pos!=0&&pos!=uri.length()-1){
				parentURI=uri.substring(0, pos+1);
			}else{
				if(pos==0)return "/";
				if(pos==uri.length()-1)return uri;
			}
		}else{
			return "";
		}
		return parentURI;
	}
	
	public static void main(String[] args){
		String uri="/";
		//System.out.println(getParentURI(uri));
	}
	
	public String getType() {
		return NODE_TYPE;
	}
}
