package com.giantleap.common.nodebean.nodeCollection;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import clustering.node.Folder;
import clustering.node.Leaf;

import com.giantleap.common.nodebean.node.base.ReflectionNode;
import com.giantleap.common.nodebean.node.base.storage.node.Node;
import com.giantleap.common.nodebean.node.base.storage.node.NodeImp;
import com.giantleap.common.nodebean.node.base.storage.node.Property;
import com.giantleap.common.nodebean.node.base.storage.path.NameInterface;
import com.giantleap.common.nodebean.node.root.file.FileRootNode;


public class NodeCollections {
	public static HashMap<String,String> _typeToJavaClassName=new HashMap<String,String>();
	
	private static List<String> _typenameList = new ArrayList<String>();
	
	private static HashMap<String,String> _moduleMap=new HashMap<String,String>();
	
	
	private static NodeCollections _NodeCollections=new NodeCollections();
	public static NodeCollections getInstance(){
		return _NodeCollections;
	}
	
	private NodeCollections(){
		registerBaseNodes();
		registerRootNodes();
		
	}
	

	public static void registerBaseNodes(){
		register(NodeImp.class);
		register(ReflectionNode.class);
		
		
		register(Folder.class);
		register(Leaf.class);
	}
	
	public static void registerRootNodes(){
		//register(AbstractRootNode.class);
		register(FileRootNode.class);
	}
	

	

	private static void registerModule(Class nodeClass){
		try{
			Field field = nodeClass.getField("DEFAULT_SRC");
			if(field==null) throw new RuntimeException();
			String str=(String)field.get(nodeClass);
			
			//str=str;
			String javaclass=nodeClass.toString().substring(6);

			String name=javaclass.substring(javaclass.lastIndexOf('.')+1);

			//name = name.toUpperCase();

			_moduleMap.put(str, javaclass);
			_moduleMap.put(name, javaclass);
			
			register(nodeClass);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
		
	
	private static void register(Class nodeClass){
		try{
			Field field = nodeClass.getField("NODE_TYPE");
			if(field==null) return;
			String str=(String)field.get(nodeClass);
			if(str!=null){
				if(str.length()>4){
					_typenameList.add(str.substring(4));
				}
				
			}
			str=str.toUpperCase();
			String javaclass=nodeClass.toString().substring(6);
			_typeToJavaClassName.put(str, javaclass);
		}catch(Exception e){
			e.printStackTrace();
		}

	}
	
	public static String getJavaClassName(String type){
		type=type.trim().toUpperCase();
		String _class= _typeToJavaClassName.get(type);
		if(_class!=null) return _class;
		type="_TP_"+type;
		return _typeToJavaClassName.get(type.toUpperCase());
	}
	
	public static String getModuleClassName(String type){
		type=type.trim();
		String _class= _moduleMap.get(type);
		return _class;
	}
	
	public static String getClassName(Class nodeClass){
		String javaclass=nodeClass.toString().substring(6);
		return javaclass;
	}

	public static Node createNode(NameInterface n,Map<String,Property> properties){
		if(n==null)throw new IllegalArgumentException("null name");
		Property idpro=properties.get(Node.ID_PROPERTY_LITERAL);
		if(idpro==null){
			
		}
		//String idString=idpro.getString();
		//NodeId id=NodeId.valueOf(idString);
		
		Property typePro=properties.get(Node.NODE_TYPE_LITERAL);
		String typeStr=null;
		if(typePro==null){
			//throw new ItemException();
		}else{
			typeStr=typePro.getString().trim();
		}
		Node node=null;
		NodeCollections collections = NodeCollections.getInstance();
		
		if(collections.getJavaClassName(typeStr.toUpperCase())!=null){
			try{
				String classname=collections.getJavaClassName(typeStr.toUpperCase());
				Class c = Class.forName(classname);
				Class[] parameterTypes={NameInterface.class,Map.class};
				Object[] arguments=new Object[]{n,properties};
				Method method=c.getMethod("valueOf", parameterTypes);
				node=(Node)method.invoke(c, arguments);
				return node;
			}catch(Exception e){
				e.printStackTrace();
				//throw new ItemException();
			}
		}
		return node;
	}
	
	public static List<String> getNodetypeList(){

		return _typenameList;
	}
	
	public static void main(String[] args){
		//register(ReflectionNode.class);
		//String javaclass=_typeToJavaClassName.get("_TP_ReflectionNode".toUpperCase());
		//System.out.println(javaclass);
		
		NodeCollections collection = NodeCollections.getInstance();
		String name = NodeCollections.getModuleClassName("Instinfo");
		System.out.println(name);
	}
	
}
