package com.giantleap.common.nodebean.persistence;

import java.lang.reflect.Method;
import java.util.HashMap;

import com.giantleap.common.nodebean.node.base.storage.node.Node;
import com.giantleap.common.nodebean.node.root.RootNodeInterface;
import com.giantleap.common.nodebean.persistence.JDOM.JDOMPersistenceMgr;

public abstract class PersistenceManager {
	public static HashMap<String,String> _typeToJavaClassName=new HashMap<String,String>();
	
	public abstract Node loadStandalone(String uri);
	//public abstract RootNodeInterface loadMountableNode(MountableNode mountableNode,String uri);
	public abstract boolean save(Node rootNode,String uri);
	public abstract boolean save(RootNodeInterface rootNode);
	
	public static final String DEFAULT_MANAGER = JDOMPersistenceMgr.JDOM_MANAGER;
	
	static{
		register();
	}
	
	private static void register(){
		_typeToJavaClassName.put("JDOMPersistenceMgr".toUpperCase(),JDOMPersistenceMgr.class.toString().substring(6));
		_typeToJavaClassName.put(JDOMPersistenceMgr.JDOM_MANAGER,JDOMPersistenceMgr.class.toString().substring(6));
	}
	
	public static String getJavaClassName(String type){
		type=type.toUpperCase().trim();
		String _class= _typeToJavaClassName.get(type.toUpperCase());
		return _class;
		
	}
	
	public static PersistenceManager getPersistenceManager(String typeStr){
		if(typeStr==null)return null;
		try{
			String classname=getJavaClassName(typeStr.toUpperCase());
			Class c = Class.forName(classname);
			Class[] parameterTypes={};
			Object[] arguments=new Object[]{};
			Method method=c.getMethod("getInstance", parameterTypes);
			PersistenceManager mgr=(PersistenceManager)method.invoke(c, arguments);
			return mgr;
		}catch(Exception e){
			e.printStackTrace();
			//throw new ItemException();
		}
		return null;
	}
	public static void main(String args[]){
		PersistenceManager obj=PersistenceManager.getPersistenceManager("JDOM");
		System.out.println(obj.getClass());
	}
}
