package com.giantleap.common.nodebean.repository;

import com.giantleap.common.nodebean.node.root.RootNodeInterface;
import com.giantleap.common.nodebean.persistence.PersistenceManager;

public class TreeRepository {
	private static TreeRepository _TreeRepository = new TreeRepository();
	public static TreeRepository getInstance(){
		return _TreeRepository;
	}
	private TreeRepository(){}
	
	public boolean save(RootNodeInterface root){
		if(root==null)return false;
		String strMgr = root.getPersistenceMgr();
		if(strMgr==null){
			strMgr = PersistenceManager.DEFAULT_MANAGER;
		}
		PersistenceManager pMgr=PersistenceManager.getPersistenceManager(strMgr);
		if(pMgr==null){
			//logger.warn("pMgr is null");
			return false;
		}
		String uri = root.getUri();
		return pMgr.save(root, uri);
	}
	
	public boolean save(RootNodeInterface root,String uri){
		if(root==null)return false;
		if(uri==null || uri.trim().equals("")) return false;
		String strMgr = root.getPersistenceMgr();
		if(strMgr==null){
			strMgr = PersistenceManager.DEFAULT_MANAGER;
		}
		PersistenceManager pMgr=PersistenceManager.getPersistenceManager(strMgr);
		if(pMgr==null){
			//logger.warn("pMgr is null");
			return false;
		}
		//String uri = root.getUri();
		return pMgr.save(root, uri);
	}
}
