package com.giantleap.common.util.dataformat;

import java.util.Calendar;
import java.util.Date;

public class DateUtil {
	public static final long SECOND = TimeConstant.SECOND;
	public static final long MIN = TimeConstant.MIN;
	public static final long HOUR= TimeConstant.HOUR;
	public static final long DAY = TimeConstant.DAY;
	
	public static Calendar getStartOfDay(Calendar cal){
		Calendar newCal = Calendar.getInstance();
		int year       = cal.get(Calendar.YEAR);
		int month      = cal.get(Calendar.MONTH)+1;
		int day        = cal.get(Calendar.DAY_OF_MONTH);
		
		newCal.set(Calendar.YEAR,year);
		newCal.set(Calendar.MONTH,month-1);
		newCal.set(Calendar.DAY_OF_MONTH,day);
		newCal.set(Calendar.HOUR_OF_DAY,0);
		newCal.set(Calendar.MINUTE,0);
		newCal.set(Calendar.SECOND,0);
		newCal.set(Calendar.MILLISECOND ,0);
		
		return newCal;
	}
	
	public static Calendar getEndOfDay(Calendar cal){
		Calendar newCal = Calendar.getInstance();
		int year       = cal.get(Calendar.YEAR);
		int month      = cal.get(Calendar.MONTH)+1;
		int day        = cal.get(Calendar.DAY_OF_MONTH);
		
		newCal.set(Calendar.YEAR,year);
		newCal.set(Calendar.MONTH,month-1);
		newCal.set(Calendar.DAY_OF_MONTH,day);
		
		newCal.set(Calendar.HOUR_OF_DAY,23);
		newCal.set(Calendar.MINUTE,59);
		newCal.set(Calendar.SECOND,59);
		newCal.set(Calendar.MILLISECOND ,999);
		
		return newCal;
	}
	

	public static String formatTime(Calendar date) {
		return formatTime(date.getTime());
	}
	
	public static String formatTime(Date date) {
		if(date==null)throw new IllegalArgumentException();
		long now=new Date(System.currentTimeMillis()).getTime();
		long time=date.getTime();
		long timeDiff = now - time;
		if(now<time) throw new IllegalArgumentException();
		

		
		if(timeDiff<2*MIN){
			return "刚刚";
		}
		if(timeDiff>=2*MIN && timeDiff<HOUR){
			long min = timeDiff/(MIN);
			return min+"分钟前";
		}

		if(timeDiff>=HOUR && timeDiff <48*HOUR){
			StringBuffer sb3=new StringBuffer();
			long hour = timeDiff/(HOUR);
			sb3.append(hour);
			sb3.append("小时前");
			return sb3.toString();
		}
		//System.out.println(timeDiff);
		//System.out.println(48*HOUR);
		//System.out.println(365*DAY);
		//System.out.println(timeDiff >= 48*HOUR && timeDiff<365*DAY);
		if(timeDiff >= 48*HOUR && timeDiff<15*DAY){
			StringBuffer sb3=new StringBuffer();
			long hour = timeDiff/(DAY);
			sb3.append(hour);
			sb3.append("天前");
			return sb3.toString();			
		}
		Calendar timeCal=Calendar.getInstance();
		timeCal.setTimeInMillis(time);

		
		int year  = timeCal.get(Calendar.YEAR);
		int month = timeCal.get(Calendar.MONTH)+1;
		int day   = timeCal.get(Calendar.DAY_OF_MONTH);
		
		StringBuffer sb3=new StringBuffer();
		sb3.append(String.valueOf(year));
		sb3.append("-");
		if(month<10) sb3.append("0");
		sb3.append(String.valueOf(month));
		sb3.append("-");
		if(day<10) sb3.append("0");
		sb3.append(String.valueOf(day));
		
		return sb3.toString();
		//SimpleDateFormat df = new SimpleDateFormat(SystemGlobals.getValue(ConfigKeys.DATE_TIME_FORMAT));
		//return df.format(date);
	}
}
