package com.giantleap.common.util.dataformat;

import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public class QuarterYear {
	public static Calendar NULL_CALENDAR=Calendar.getInstance();
	private static final int MIN = 60*1000;
	private static final int HOUR= 60*60*1000;
	private static final int DAY = 24*HOUR;
	
	
	public static int EXAMPLE_YEAR=1980;
	
	public static Calendar Q1Start;
	public static Calendar Q1End;
	public static Calendar Q2Start;
	public static Calendar Q2End;
	public static Calendar Q3Start;
	public static Calendar Q3End;
	public static Calendar Q4Start;
	public static Calendar Q4End;
	
	public static Map<Integer,Calendar> quarterStart=new HashMap<Integer,Calendar>();
	public static Map<Integer,Calendar> quarterEnd=new HashMap<Integer,Calendar>();
	static{
		NULL_CALENDAR.setTimeInMillis(0L);
		
		Calendar cal1 = Calendar.getInstance();
		cal1.set(Calendar.YEAR, EXAMPLE_YEAR);
		cal1.set(Calendar.MONTH,Calendar.JANUARY);
		cal1.set(Calendar.DAY_OF_MONTH,1);
		setStartOfDay(cal1);
		Q1Start=cal1;
		
		Calendar cal2 = Calendar.getInstance();
		cal2.set(Calendar.YEAR, EXAMPLE_YEAR);
		cal2.set(Calendar.MONTH,Calendar.MARCH);
		cal2.set(Calendar.DAY_OF_MONTH,31);
		setEndOfDay(cal2);
		Q1End=cal2;
		
		Calendar cal3 = Calendar.getInstance();
		cal3.set(Calendar.YEAR, EXAMPLE_YEAR);
		cal3.set(Calendar.MONTH,Calendar.APRIL);
		cal3.set(Calendar.DAY_OF_MONTH,1);
		setStartOfDay(cal3);
		Q2Start=cal3;
		
		Calendar cal4 = Calendar.getInstance();
		cal4.set(Calendar.YEAR, EXAMPLE_YEAR);
		cal4.set(Calendar.MONTH,Calendar.JUNE);
		cal4.set(Calendar.DAY_OF_MONTH,30);
		setEndOfDay(cal4);
		Q2End=cal4;
		
		Calendar cal5 = Calendar.getInstance();
		cal5.set(Calendar.YEAR, EXAMPLE_YEAR);
		cal5.set(Calendar.MONTH,Calendar.JULY);
		cal5.set(Calendar.DAY_OF_MONTH,1);
		setStartOfDay(cal5);
		Q3Start=cal5;
		
		Calendar cal6 = Calendar.getInstance();
		cal6.set(Calendar.YEAR, EXAMPLE_YEAR);
		cal6.set(Calendar.MONTH,Calendar.SEPTEMBER);
		cal6.set(Calendar.DAY_OF_MONTH,30);
		setEndOfDay(cal6);
		Q3End=cal6;
		
		Calendar cal7 = Calendar.getInstance();
		cal7.set(Calendar.YEAR, EXAMPLE_YEAR);
		cal7.set(Calendar.MONTH,Calendar.OCTOBER);
		cal7.set(Calendar.DAY_OF_MONTH,1);
		setStartOfDay(cal7);
		Q4Start=cal7;
		
		Calendar cal8 = Calendar.getInstance();
		cal8.set(Calendar.YEAR, EXAMPLE_YEAR);
		cal8.set(Calendar.MONTH,Calendar.DECEMBER);
		cal8.set(Calendar.DAY_OF_MONTH,31);
		setEndOfDay(cal8);
		Q4End=cal8;
		
		quarterStart.put(1, Q1Start);
		quarterStart.put(2, Q2Start);
		quarterStart.put(3, Q3Start);
		quarterStart.put(4, Q4Start);
		
		quarterEnd.put(1, Q1End);
		quarterEnd.put(2, Q2End);
		quarterEnd.put(3, Q3End);
		quarterEnd.put(4, Q4End);
	}
	
	public static Calendar getQuarterStart(Calendar cal){
		int quarter = getQuarter(cal);
		Calendar start = quarterStart.get(quarter);
		return getDiffYearCalendar(start,cal.get(Calendar.YEAR));
	}
	
	public static Calendar getQuarterEnd(Calendar cal){
		int quarter = getQuarter(cal);
		Calendar end = quarterEnd.get(quarter);
		return getDiffYearCalendar(end,cal.get(Calendar.YEAR));
	}
	
	public static int getQuarter(Calendar cal){
		int year  = cal.get(Calendar.YEAR);
		cal.set(Calendar.YEAR,EXAMPLE_YEAR);
		int quarter = -1;
		if(cal.after(Q1Start)&&cal.before(Q1End)){
			quarter = 1;
		}
		if(cal.after(Q2Start)&&cal.before(Q2End)){
			quarter = 2;
		}
		if(cal.after(Q3Start)&&cal.before(Q3End)){
			quarter = 3;
		}
		if(cal.after(Q4Start)&&cal.before(Q4End)){
			quarter = 4;
		}
		cal.set(Calendar.YEAR,year);
		return quarter;
	}
	
	public static Calendar getDiffYearCalendar(Calendar cal,int year){
		Calendar newCal = Calendar.getInstance();	
		//int year  = cal.get(Calendar.YEAR);
		int month      = cal.get(Calendar.MONTH)+1;
		int day        = cal.get(Calendar.DAY_OF_MONTH);
		int hour       = cal.get(Calendar.HOUR_OF_DAY);
		int minute     = cal.get(Calendar.MINUTE);
		int second     =cal.get(Calendar.SECOND);
		int millisecond=cal.get(Calendar.MILLISECOND);
		
		newCal.set(Calendar.YEAR,year);
		newCal.set(Calendar.MONTH,month-1);
		newCal.set(Calendar.DAY_OF_MONTH,day);
		newCal.set(Calendar.HOUR_OF_DAY,hour);
		newCal.set(Calendar.MINUTE,minute);
		newCal.set(Calendar.SECOND,second);
		newCal.set(Calendar.MILLISECOND,millisecond);
		
		return newCal;
	}
	
	public static void setStartOfDay(Calendar cal){
		cal.set(Calendar.HOUR_OF_DAY,0);
		cal.set(Calendar.MINUTE,0);
		cal.set(Calendar.SECOND,0);
		cal.set(Calendar.MILLISECOND ,0);
	}
	
	public static void setEndOfDay(Calendar cal){
		cal.set(Calendar.HOUR_OF_DAY,23);
		cal.set(Calendar.MINUTE,59);
		cal.set(Calendar.SECOND,59);
		cal.set(Calendar.MILLISECOND ,999);
	}
	
	public static Calendar getNow(){
		Calendar cal = Calendar.getInstance();
		Date date = new Date();
		cal.setTime(date);
		return cal;
	}
	
	public static Calendar getCalendar2(String str){
		if(str==null) throw new IllegalArgumentException("null");
		Calendar cal=Calendar.getInstance();
		//String strYear=str.substring(0,str.indexOf('-'));
		//String strMonth=str.substring(str.indexOf('-')+1,str.lastIndexOf('-'));
		//String strDay=str.substring(str.lastIndexOf('-')+1);
		//System.out.println(strYear);
		//System.out.println(strMonth);
		//System.out.println(strDay);
		
		String strYear=str.substring(0,4);
		String strMonth=str.substring(4,6);
		String strDay=str.substring(6,8);
		try{
			int year=Integer.parseInt(strYear);
			int month=Integer.parseInt(strMonth);
			int day=Integer.parseInt(strDay);
			cal.set(Calendar.YEAR,year);
			cal.set(Calendar.MONTH,month-1);
			cal.set(Calendar.DAY_OF_MONTH,day);
			setStartOfDay(cal);
		}catch(NumberFormatException e){
			return NULL_CALENDAR;
		}
		//System.out.println(cal);
		return cal;
	}
	
	public static Calendar getCalendar(String str){
		if(str==null) throw new IllegalArgumentException("null");
		Calendar cal=Calendar.getInstance();
		String strYear=str.substring(0,str.indexOf('-'));
		String strMonth=str.substring(str.indexOf('-')+1,str.lastIndexOf('-'));
		String strDay=str.substring(str.lastIndexOf('-')+1);
		//System.out.println(strYear);
		//System.out.println(strMonth);
		//System.out.println(strDay);
		try{
			int year=Integer.parseInt(strYear);
			int month=Integer.parseInt(strMonth);
			int day=Integer.parseInt(strDay);
			cal.set(Calendar.YEAR,year);
			cal.set(Calendar.MONTH,month-1);
			cal.set(Calendar.DAY_OF_MONTH,day);
		}catch(NumberFormatException e){
			return NULL_CALENDAR;
		}
		//System.out.println(cal);
		return cal;
	}
	
	public static String getCalendarDateString(Calendar cal){
		if(cal==null) throw new IllegalArgumentException("null");
		StringBuffer sb3=new StringBuffer();
		int year  = cal.get(Calendar.YEAR);
		int month = cal.get(Calendar.MONTH)+1;
		int day   = cal.get(Calendar.DAY_OF_MONTH);
		sb3.append(String.valueOf(year));
		sb3.append("-");
		if(month<10) sb3.append("0");
		sb3.append(String.valueOf(month));
		sb3.append("-");
		if(day<10) sb3.append("0");
		sb3.append(String.valueOf(day));
		return sb3.toString();
	}
}
