package com.giantleap.common.util.uuid;



public class Base64 {

	public static final int UUID_BYTE_LENGTH = 16;

	public static final int BYTE_BITS_LENGTH = 8;
	public static final int CODE_BITS_LENGTH = 6;

	// "final" the best; I just don't want to type...
	public static char[] CHARSET = null;

	public static void init() {
		CHARSET = new char[64];

		int i = 0;
		for (char c = '0'; c <= '9'; c++, i++)
			CHARSET[i] = c;
		for (char c = 'A'; c <= 'Z'; c++, i++)
			CHARSET[i] = c;
		for (char c = 'a'; c <= 'z'; c++, i++)
			CHARSET[i] = c;

		CHARSET[i] = '.';
		CHARSET[i + 1] = '-';
	}

	public static String encode(byte[] data) throws IllegalArgumentException {
		if (CHARSET == null)
			init();

		if (data.length != UUID_BYTE_LENGTH)
			throw new IllegalArgumentException(
					"UUID must be constructed using a 16 byte array.");

		String strBuffer = "";

		int top = 0;
		int buffer = 0;

		for (int i = UUID_BYTE_LENGTH - 1; i >= 0; i--) {
			buffer = buffer | ((data[i] & 0xFF) << top);
			top += BYTE_BITS_LENGTH;

			while (top > CODE_BITS_LENGTH) {
				strBuffer = CHARSET[buffer & (CHARSET.length - 1)] + strBuffer;
				buffer >>>= CODE_BITS_LENGTH;
				top -= CODE_BITS_LENGTH;
			}
		}

		if (top > 0)
			strBuffer = CHARSET[buffer & (CHARSET.length - 1)] + strBuffer;

		return strBuffer;
	}
	

	/**
	 * test
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		byte[] id = new byte[16];
		for (int i = 0; i < 16; i++) {
			id[i] = (byte) ((Math.random() - 0.5) * 2 * 128);
		}

		//System.out.println(Arrays.toString(id));
		//System.out.println(Base64.encode(id));
		
		UUID uuid=UUID.randomUUID();
		byte[] bytes=uuid.getRawBytes();
		
		System.out.println(uuid.toString());
		System.out.println(Base64.encode(bytes));
	}
}
